import 'dart:convert';

import 'package:dio/dio.dart';
import 'package:example/com.xh.example/model/rank_model.dart';
import 'package:xh_framework/xh_framework.dart';

abstract class ITestRequest {
  void testGet(
      {OnSuccessCallback<RankModel> onSuccess, OnErrorCallback onError});

  void testPost({OnSuccessCallback<String> onSuccess, OnErrorCallback onError});

  void testDownload(
      {OnSuccessCallback<String> onSuccess,
      OnErrorCallback onError,
      OnProgressCallback onProgress});
}

class TestRequest extends XHHttpRequest implements ITestRequest {
  static TestRequest _instance;

  TestRequest._internal();

  factory TestRequest.getInstance() => _getInstance();

  static _getInstance() {
    if (_instance == null) {
      _instance = TestRequest._internal();
    }
    return _instance;
  }

  @override
  void testGet({onSuccess, onError}) {
    Map<String, dynamic> map = {'test': 123};
    getRequest(
        'http://api.zhuishushenqi.com/ranking/54d43437d47d13ff21cad58b', map,
        onSuccess: (data) {
      onSuccess(RankModel.fromJson(data));
    }, onError: onError);
  }

  @override
  void testPost({onSuccess, onError}) {
    Map<String, dynamic> map = {'username': 'wuchuang', 'password': 123456};
    postRequest('https://www.wanandroid.com/user/login', map,
        onSuccess: onSuccess, onError: onError);
  }

  @override
  void testDownload({onSuccess, onError, onProgress}) {
    String url =
        'http://apk.gfan.net.cn/index.php?c=api&m=down&src=wap&apk=21000';
    var path = "/storage/emulated/0/test.apk";
    downloadRequest(url, path,
        onSuccess: onSuccess, onError: onError, onProgress: onProgress);
  }
}
