import 'package:flutter/material.dart';
import 'package:xh_framework/com/xh/widget/loader_widget.dart';
import 'package:fluttertoast/fluttertoast.dart';

typedef void OnTapListCallback(int index, int action, dynamic data);

abstract class XHListStatefulWidget<Model> extends StatefulWidget {
  XHListStatefulWidget({this.index, this.onListTap, this.data}) : super();

  final int index;
  final Model data;
  final OnTapListCallback onListTap;

  @override
  State<XHListStatefulWidget> createState() ;

}

abstract class XHListStatefulWidgetState<T extends XHListStatefulWidget, Model>
    extends State<T> {
  XHListStatefulWidgetState({this.data}) : super();
  final Model data;

  void onChildTap(int index, int action, [dynamic data]) {
    if (widget.onListTap != null) {
      widget.onListTap(index, action, data);
    }
  }

  void showLoader() {
    showDialog(
        context: context,
        builder: (context) {
          return new LoaderWidget('正在加载...');
        });
  }

  void showToast(String message) {
    Fluttertoast.showToast(msg: message);
  }


  void closeLoader() {
    Navigator.of(context).pop();
  }

}

abstract class XHListStatelessWidget<Model> extends StatelessWidget {
  XHListStatelessWidget({this.index, this.onListTap, this.data}) : super();

  final int index;
  final Model data;
  final OnTapListCallback onListTap;

  void onChildTap(int index, int action, [dynamic data]) {
    if (onListTap != null) {
      onListTap(index, action, data);
    }
  }
}
