class NetworkException implements Exception {
  NetworkException({this.action, this.message});

  final int action;
  final String message;

  static const int connectionTimeout = 1;
  static const int readTimeout = connectionTimeout + 1;
  static const int writeTimeout = readTimeout + 1;
  static const int serverError = writeTimeout + 1;
  static const int clientError = serverError + 1;
  static const int cancelError = clientError + 1;
  static const int otherError = cancelError + 1;
  static const int fileError = otherError + 1;

  static const String connectionTimeoutMsg = '连接超时，请检查网络';
  static const String readTimeoutMsg = '读取超时，请检查网络';
  static const String writeTimeoutMsg = '写入超时，请检查网络';
  static const String serverErrorMsg = '服务端错误';
  static const String clientErrorMsg = '客户端错误';
  static const String cancelErrorMsg = '取消请求';
  static const String otherErrorMsg = '未知错误';
}
