import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:xh_framework/com/xh/base/xh_widget.dart';

class LoaderWidget extends XHStatefulWidget<String> {
  LoaderWidget(data) : super(data: data);

  @override
  State<XHStatefulWidget> createState() {
    return LoaderWidgetState(data);
  }
}

class LoaderWidgetState extends XHStatefulWidgetState<LoaderWidget, String> {
  LoaderWidgetState(data) : super(data: data);

  @override
  Widget build(BuildContext context) {
    return new Container(
      child: Material(
        type: MaterialType.transparency,
        child: Center(
          child: SizedBox(
            width: 120,
            height: 120,
            child: Container(
              decoration: ShapeDecoration(
                  color: Color(0xffffffff),
                  shape: RoundedRectangleBorder(
                      borderRadius: BorderRadius.all(Radius.circular(8.0)))),
              child: new Column(
                mainAxisAlignment: MainAxisAlignment.center,
                crossAxisAlignment: CrossAxisAlignment.center,
                children: <Widget>[
                  CircularProgressIndicator(),
                  Padding(
                    padding: const EdgeInsets.only(top: 20),
                    child: Text(
                      data,
                      style: TextStyle(fontSize: 12),
                    ),
                  )
                ],
              ),
            ),
          ),
        ),
      ),
    );
  }
}
